package untitled5;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import untitled4.*;
import java.beans.*;

public class Frame1 extends JFrame
{
    JMenuBar menuBar1 = new JMenuBar();
    JMenu menuFile = new JMenu();
    JMenuItem menuFileExit = new JMenuItem();
    JMenu menuHelp = new JMenu();
    JMenuItem menuHelpAbout = new JMenuItem();
    JLabel statusBar = new JLabel();
    BorderLayout borderLayout1 = new BorderLayout();
    NSEWBean nSEWBean1 = new NSEWBean();

    //Construct the frame
  public Frame1()
    {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try 
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    //Component initialization
  private void jbInit() throws Exception 
    {
        this.getContentPane().setLayout(borderLayout1);
        this.setSize(new Dimension(400, 300));
        this.setTitle("Frame Title");
        statusBar.setText(" ");
        menuFile.setText("File");
        menuFileExit.setText("Exit");
        menuFileExit.addActionListener(new ActionListener() 
        {

            public void actionPerformed(ActionEvent e)
            {
                fileExit_actionPerformed(e);
            }
        });
        menuHelp.setText("Help");
        menuHelpAbout.setText("About");
        menuHelpAbout.addActionListener(new ActionListener() 
        {

            public void actionPerformed(ActionEvent e)
            {
                helpAbout_actionPerformed(e);
            }
        });
        nSEWBean1.addPropertyChangeListener(new java.beans.PropertyChangeListener()
        {

            public void propertyChange(PropertyChangeEvent e)
            {
                nSEWBean1_propertyChange(e);
            }
        });
        nSEWBean1.addVetoableChangeListener(new java.beans.VetoableChangeListener()
        {

            public void vetoableChange(PropertyChangeEvent e) throws PropertyVetoException
            {
                nSEWBean1_vetoableChange(e);
            }
        });
        menuFile.add(menuFileExit);
        menuHelp.add(menuHelpAbout);
        menuBar1.add(menuFile);
        menuBar1.add(menuHelp);
        this.setJMenuBar(menuBar1);
        this.getContentPane().add(statusBar, BorderLayout.SOUTH);
        this.getContentPane().add(nSEWBean1, BorderLayout.CENTER);
    }

    //File | Exit action performed
  public void fileExit_actionPerformed(ActionEvent e)
    {
        System.exit(0);
    }

    //Help | About action performed
  public void helpAbout_actionPerformed(ActionEvent e)
    {
        Frame1_AboutBox dlg = new Frame1_AboutBox(this);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        dlg.setModal(true);
        dlg.show();
    }

    //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e)
    {
        super.processWindowEvent(e);
        if(e.getID() == WindowEvent.WINDOW_CLOSING)
        {
            fileExit_actionPerformed(null);
        }
    }

    void nSEWBean1_propertyChange(PropertyChangeEvent e)
    {
        statusBar.setText("property " + e.getPropertyName() + " changed to " + e.getNewValue());
    }

    void nSEWBean1_vetoableChange(PropertyChangeEvent e) throws PropertyVetoException
    {
        if (e.getPropertyName() == "xPos")
        {
            Integer iObj = (Integer) e.getNewValue();
            int newX = iObj.intValue();

            if (Math.abs(newX) > 5)
                throw new PropertyVetoException("Bananen X Wert", e);
        }
    }
}
